

.LP
\fBunits:\fR \fCin\fR | \fCcm\fR
.IP \0
The measurement unit to be used for absolute units, either inches or centimeters.
Default is \fCin\fR.
If this is set in the config file, it will be in effect when command line
arguments are evaluated.  If set in \fBproc settings\fR, it will not have any
effect on command line argument evaluation.
.br
Example: \fCunits: cm\fR


.LP
\fBnumbernotation:\fR \fCstandard\fR | \fCus\fR | \fCeuro\fR
.IP \0
Specifies how decimal point and thousands separators will be displayed.  
Default is \fCstandard\fR.
The following table illustrates:
.sp
.nf
 standard           us             euro
----------    ------------    -------------
     79              79               79
     79.5            79.5             79,5  
   4321.79         4321.79          4321,79 
  54321          54,321           54.321
 654321.07      654,321.07       654.321,07
1987654321    1,987,654,321    1.987.654.321

.LP
\fBnumberspacerthreshold:\fR  \fIn\fR
.IP \0
Specifies at what numeric magnitude thousands separators will begin to be inserted.
Default is 4, and this is used in the above table.  If it were set to \fC3\fR, the third entry
in the above table would appear like this:
.nf
   4321.79         4,321.79          4.321,79 
.fi


.LP
\fBfont\fR \fIfontname\fR
.IP \0
Make \fIfontname\fR the default font.  
For more information see
.ig >>
<a href="fonts.html">
.>>
\0fonts.
.ig >>
</a>
.>>


.ig >>
<br><br><br>
.>>
.SH SVG / XML SETTINGS

.LP
\fBxml_declaration\fR  \fCyes | no\fR
.IP \0
By default the first line of the SVG result will be the XML declaration \fC<?xml .. >\fR .
Use \fCno\fR to suppress the XML declaration line if
the SVG result is to be embedded into a larger XML document.
This may also be done using the \fC-omit_xml_declaration\fR
.ig >>
<a href="pl.1.html">
.>>
\0command line argument.
.ig >>
</a>
.>>

.LP
\fBxml_encoding\fR  \fImethod\fR
.IP \0
This may be used to set the XML character encoding method.  
It has no effect when \fCxml_declaration\fR is \fCno\fR.
The default is \fCiso-8859-1\fR which provides Latin and Western European character sets.
For Unicode fonts this should be set to \fCutf-8\fR (for more discussion see the Unicode section in 
.ig >>
<a href="fonts.html">
.>>
\0fonts
.ig >>
</a>
.>>
).  
Equivalent to the \fC-xml_encoding\fR
.ig >>
<a href="pl.1.html">
.>>
\0command line argument.
.ig >>
</a>
.>>




.ig >>
<br><br><br>
.>>

.SH SYSTEM ENVIRONMENT

.LP
\fBcpulimit:\fR
.IP \0
Number of seconds of CPU time that will be allowed to the \fBpl\fR or \fBpltab\fR process
or any spawned subprocesses.  Default is 10 seconds.
Any process exceeding this will abort.

.LP
\fBfilesizelimit:\fR \fB[DISCONTINUED]\fR
.IP \0
This attribute no longer does anything.  It turned out to be more of a problem than a benefit.


.ig >>
<br><br><br>
.>>

.SH DATE-RELATED

.LP
\fBdateformat:\fR \fIformat\fR
.IP \0
Set the current date format.
\fIformat\fR must be a
date format from the
.ig >>
<a href="dates.html">
.>>
\0dates manual page
.ig >>
</a>
.>>
that includes month, day, and year, for which arithmetic is supported.
To use other arithmetic date formats (such as quarter notation)
specify the format in the 
.ig >>
<a href="areadef.html">
.>>
\0proc areadef
.ig >>
</a>
.>>
xscaletype or yscaletype attribute.
.br
Example: \fCdateformat: dd-mmm-yyyy\fR


.LP
\fBomitweekends\fR  \fComit\fR | \fCadjust\fR | \fCyes\fR | \fCno\fR
.IP \0
Allows date plotting as if
Saturdays and Sundays did not exist.
Mondays will follow Fridays directly.  
Useful in certain business and work-related plots.
.br
If \fComit\fR, any Saturday or Sunday dates encountered will be considered invalid and omitted;
however they will not be reported unless the -showbad command line option is used.
.br
If \fCadjust\fR or \fCyes\fR, any Saturday or Sunday dates encountered will be silently adjusted 
to the nearest weekday.


.fi
.LP
\fBpivotyear:\fR \fIyy\fR
.IP \0
Set the two digit year that should be used to convert
two-digit years to four-digit years.  If two-digit years are 
used, year values that are less than the pivot year are assumed
to be 21st century years.  Default is 77.
.br
Example: \fCpivotyear: 50\fR

.LP
\fBmonths:\fR \fIlist\fR
.IP \0
Specify the three-character month abbreviations to be used, all in lower case,
beginning with the first month.
Default is the English (\fCjan feb mar apr may jun jul aug sep oct nov dec\fR).
.br
Example (Spanish) (must all be on one line): 
.br
\fCmonths: ene feb mar abr pue jun jul ago sep oct nov dic\fR

.LP
\fBmonths.abbrev:\fR \fIlist\fR
.IP \0
short month names, capitalized for presentation, begining with the first month.
Default is English (\fCJan Feb Mar Apr May June July Aug Sept Oct Nov Dec\fR).
.br
Example (Spanish) (must all be on one line): 
.br
\fCmonths.abbrev: Ene Feb Mar Abr Pue Jun Jul Ago Sep Oct Nov Dic\fR

.LP
\fBmonths.full:\fR \fIlist\fR
.IP \0
full month names, capitalized for presentation.
.br
Example (Spanish) (must all be on one line): 
.br
\fCmonths.full: Enero Febrero Marcha Abril Pueda Junio Julio Agosto Septiembre Octubre Noviembre Diciembre\fR

.LP
\fBweekdays:\fR  \fIlist\fR
.IP \0
three-character weekday abbreviations, capitalized for presentation,
beginning with Sunday.
.br 
Example (French): \fCweekdays: Dim Lun Mar Mer Jeu Ven Sam\fR
.br
Example (Spanish): \fCweekdays: Dom Lun Mar Mie Jue Vie Sab\fR

.LP
\fBlazydates\fR  \fCmonth\fR|\fCday\fR|\fCboth\fR
.IP \0
Allow handling of dates where the day component
or the month component is not known.  See
.ig >>
<a href="dates.html">
.>>
\0dates
.ig >>
</a>
.>>
for further discussion of lazy dates.


.ig >>
<br>
<br>
</td></tr>
<td align=right>
<a href="../doc/Welcome.html">
<img src="../doc/ploticus.gif" border=0></a><br><small>data display engine &nbsp; <br>
<a href="../doc/Copyright.html">Copyright Steve Grubb</a>
<br>
<br>
<center>
<img src="../gallery/all.gif">
</center>
</td></tr>
</table>
.>>
